class sandy.core.face.QuadFace3D extends sandy.core.face.TriFace3D
{
   var _vd;
   var _va;
   var _vb;
   var _vc;
   var _mc;
   var _bEv;
   var _bV;
   var _sb;
   var _s;
   function QuadFace3D(oref, pt1, pt2, pt3, pt4)
   {
      super(oref,pt1,pt2,pt3);
      this._vd = pt4;
   }
   function getVertex(Void)
   {
      return [this._va,this._vb,this._vc,this._vd];
   }
   function setSkin(s)
   {
      if(s.getType() == sandy.skin.SkinType.TEXTURE)
      {
         trace("WARNING: Sandy::QuadFace3D The perspective bitmap distortion may not be correct");
      }
      super.setSkin(s);
   }
   function render(mc)
   {
      this._mc = mc;
      if(this._bEv)
      {
         this.__prepareEvents(mc);
      }
      !this._bV ? this._sb.begin(this,mc) : this._s.begin(this,mc);
      mc.moveTo(this._va.sx,this._va.sy);
      mc.lineTo(this._vb.sx,this._vb.sy);
      mc.lineTo(this._vc.sx,this._vc.sy);
      mc.lineTo(this._vd.sx,this._vd.sy);
      mc.lineTo(this._va.sx,this._va.sy);
      !this._bV ? this._sb.end(this,mc) : this._s.end(this,mc);
   }
   function refresh(Void)
   {
      this._mc.clear();
      !this._bV ? this._sb.begin(this,this._mc) : this._s.begin(this,this._mc);
      this._mc.moveTo(this._va.sx,this._va.sy);
      this._mc.lineTo(this._vb.sx,this._vb.sy);
      this._mc.lineTo(this._vc.sx,this._vc.sy);
      this._mc.lineTo(this._vd.sx,this._vd.sy);
      this._mc.lineTo(this._va.sx,this._va.sy);
      !this._bV ? this._sb.end(this,this._mc) : this._s.end(this,this._mc);
   }
   function getZAverage(Void)
   {
      return (this._va.wz + this._vb.wz + this._vc.wz + this._vd.wz) / 4;
   }
   function getMinDepth(Void)
   {
      return Math.min(this._vd.wz,super.getMinDepth());
   }
   function getMaxDepth(Void)
   {
      return Math.max(this._vd.wz,super.getMaxDepth());
   }
   function toString(Void)
   {
      return new String("sandy.core.face.QuadFace3D");
   }
}
