class sandy.view.Camera3D
{
   var _p;
   var is;
   var _nFocal;
   var _vOut;
   var _vSide;
   var _vUp;
   var _nRoll;
   var _nTilt;
   var _nYaw;
   var _rDim;
   var _mt;
   var _mp;
   var m;
   var _mv;
   var _compiled;
   var _oInt;
   function Camera3D(nFoc, s)
   {
      this._p = new sandy.core.data.Vector();
      this.is = s;
      this._nFocal = nFoc;
      this._vOut = new sandy.core.data.Vector(0,0,1);
      this._vSide = new sandy.core.data.Vector(1,0,0);
      this._vUp = new sandy.core.data.Vector(0,1,0);
      this._nRoll = 0;
      this._nTilt = 0;
      this._nYaw = 0;
      this.is.setCamera(this);
      this._rDim = this.is.getSize();
      this._mt = this._mp = this.m = this._mv = sandy.core.data.Matrix4.createIdentity();
      this._compiled = false;
      this.__loadSimpleProjection();
      this._oInt = null;
   }
   function moveSideways(d)
   {
      this._compiled = false;
      this._p.x += this._vSide.x * d;
      this._p.y += this._vSide.y * d;
      this._p.z += this._vSide.z * d;
   }
   function moveUpwards(d)
   {
      this._compiled = false;
      this._p.x += this._vUp.x * d;
      this._p.y += this._vUp.y * d;
      this._p.z += this._vUp.z * d;
   }
   function moveForward(d)
   {
      this._compiled = false;
      this._p.x += this._vOut.x * d;
      this._p.y += this._vOut.y * d;
      this._p.z += this._vOut.z * d;
   }
   function moveHorizontally(d)
   {
      this._compiled = false;
      this._p.x += this._vOut.x * d;
      this._p.z += this._vOut.z * d;
   }
   function moveVertically(d)
   {
      this._compiled = false;
      this._p.y -= d;
   }
   function translate(px, py, pz)
   {
      this._compiled = false;
      this._p.x += px;
      this._p.y -= py;
      this._p.z += pz;
   }
   function moveLateraly(d)
   {
      this._compiled = false;
      this._p.x += d;
   }
   function rotateAxis(ax, ay, az, nAngle)
   {
      this._compiled = false;
      nAngle = (nAngle + 360) % 360;
      var _loc2_ = Math.sqrt(ax * ax + ay * ay + az * az);
      var _loc3_ = sandy.math.Matrix4Math.axisRotation(ax / _loc2_,ay / _loc2_,az / _loc2_,nAngle);
      sandy.math.Matrix4Math.vectorMult3x3(_loc3_,this._vSide);
      sandy.math.Matrix4Math.vectorMult3x3(_loc3_,this._vUp);
      sandy.math.Matrix4Math.vectorMult3x3(_loc3_,this._vOut);
   }
   function lookAt(px, py, pz)
   {
      this._compiled = false;
      this._vOut = sandy.math.VectorMath.sub(new sandy.core.data.Vector(px,- py,pz),this._p);
      sandy.math.VectorMath.normalize(this._vOut);
      this._vSide = sandy.math.VectorMath.cross(this._vOut,new sandy.core.data.Vector(0,-1,0));
      sandy.math.VectorMath.normalize(this._vSide);
      this._vUp = sandy.math.VectorMath.cross(this._vOut,this._vSide);
      sandy.math.VectorMath.normalize(this._vUp);
   }
   function rotateX(nAngle)
   {
      this._compiled = false;
      nAngle = (nAngle + 360) % 360;
      var _loc2_ = sandy.math.Matrix4Math.axisRotation(1,0,0,nAngle);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vUp);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vSide);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vOut);
   }
   function rotateY(nAngle)
   {
      this._compiled = false;
      nAngle = (nAngle + 360) % 360;
      var _loc2_ = sandy.math.Matrix4Math.axisRotation(0,1,0,nAngle);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vUp);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vSide);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vOut);
   }
   function rotateZ(nAngle)
   {
      this._compiled = false;
      nAngle = (nAngle + 360) % 360;
      var _loc2_ = sandy.math.Matrix4Math.axisRotation(0,0,1,nAngle);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vUp);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vSide);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vOut);
   }
   function tilt(nAngle)
   {
      this._compiled = false;
      nAngle = (nAngle + 360) % 360;
      var _loc2_ = sandy.math.Matrix4Math.axisRotation(this._vSide.x,this._vSide.y,this._vSide.z,nAngle);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vUp);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vOut);
   }
   function pan(nAngle)
   {
      this._compiled = false;
      nAngle = (nAngle + 360) % 360;
      var _loc2_ = sandy.math.Matrix4Math.axisRotation(this._vUp.x,this._vUp.y,this._vUp.z,nAngle);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vSide);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vOut);
   }
   function roll(nAngle)
   {
      this._compiled = false;
      nAngle = (nAngle + 360) % 360;
      var _loc2_ = sandy.math.Matrix4Math.axisRotation(this._vOut.x,this._vOut.y,this._vOut.z,nAngle);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vSide);
      sandy.math.Matrix4Math.vectorMult3x3(_loc2_,this._vUp);
   }
   function setPosition(x, y, z)
   {
      this._compiled = false;
      this._p.x = x;
      this._p.y = - y;
      this._p.z = z;
   }
   function getXOffset(Void)
   {
      return this._rDim.width / 2;
   }
   function getYOffset(Void)
   {
      return this._rDim.height / 2;
   }
   function getPosition(Void)
   {
      return new sandy.core.data.Vector(this._p.x,- this._p.y,this._p.z);
   }
   function setScreen(s)
   {
      this.is = s;
      this._rDim = this.is.getSize();
      this.is.setCamera(this);
   }
   function setFocal(n)
   {
      this._compiled = false;
      this._nFocal = n;
      this.__loadSimpleProjection();
   }
   function getFocal(Void)
   {
      return this._nFocal;
   }
   function setInterpolator(i)
   {
      if(i.getType() == sandy.core.transform.TransformType.PATH_INTERPOLATION || i.getType() == sandy.core.transform.TransformType.TRANSLATION_INTERPOLATION)
      {
         this.removeInterpolator();
         this._oInt = i;
         this._oInt.addEventListener(sandy.events.InterpolationEvent.onProgressEVENT,this,this.__onInterpolation);
         return true;
      }
      return false;
   }
   function removeInterpolator(Void)
   {
      if(null == this._oInt)
      {
         return false;
      }
      this._oInt.removeEventListener(sandy.events.InterpolationEvent.onProgressEVENT,this);
      delete this._oInt;
      this._oInt = null;
      return true;
   }
   function isModified(Void)
   {
      return this._compiled == false;
   }
   function compile(Void)
   {
      if(!this._compiled)
      {
         this._mt = this.__updateRotationMatrix();
         this._mt = sandy.math.Matrix4Math.multiply(this._mt,sandy.math.Matrix4Math.translation(- this._p.x,- this._p.y,- this._p.z));
         this.m = sandy.math.Matrix4Math.multiply(this._mp,this._mt);
         this._compiled = true;
      }
   }
   function getProjectionMatrix(Void)
   {
      return this._mp;
   }
   function getTransformMatrix(Void)
   {
      return this._mt;
   }
   function __loadPerspective(fovy, aspect, zNear, zFar)
   {
      var _loc5_ = sandy.util.NumberUtil.toRadian(fovy / 2);
      var _loc4_ = 1 / Math.tan(_loc5_);
      this._mp.n11 = _loc4_ / aspect;
      this._mp.n12 = 0;
      this._mp.n13 = 0;
      this._mp.n14 = 0;
      this._mp.n21 = 0;
      this._mp.n22 = _loc4_;
      this._mp.n23 = 0;
      this._mp.n24 = 0;
      this._mp.n31 = 0;
      this._mp.n32 = 0;
      this._mp.n33 = (zFar + zNear) / (zNear - zFar);
      this._mp.n34 = 2 * zFar * zNear / (zNear - zFar);
      this._mp.n41 = 0;
      this._mp.n42 = 0;
      this._mp.n43 = -1;
      this._mp.n44 = 0;
   }
   function __loadPerspective2(left, right, top, bottom, zNear, zFar)
   {
      this._mp.n11 = 2 * zNear / (right - left);
      this._mp.n12 = 0;
      this._mp.n13 = (right + left) / (right - left);
      this._mp.n14 = 0;
      this._mp.n21 = 0;
      this._mp.n22 = 2 * zNear / (top - bottom);
      this._mp.n23 = (top + bottom) / (top - bottom);
      this._mp.n24 = 0;
      this._mp.n31 = 0;
      this._mp.n32 = 0;
      this._mp.n33 = (zFar + zNear) / (zNear - zFar);
      this._mp.n34 = 2 * zFar * zNear / (zNear - zFar);
      this._mp.n41 = 0;
      this._mp.n42 = 0;
      this._mp.n43 = -1;
      this._mp.n44 = 0;
   }
   function math_matrix4d_frustum(par_d_left, par_d_right, par_d_bottom, par_d_top, par_d_z_near, par_d_z_far)
   {
      var _loc2_ = undefined;
      var _loc6_ = undefined;
      var _loc4_ = undefined;
      delete this._mp;
      this._mp = sandy.core.data.Matrix4.createZero();
      _loc2_ = par_d_right - par_d_left;
      _loc6_ = par_d_top - par_d_bottom;
      _loc4_ = par_d_z_near - par_d_z_far;
      this._mp.n11 = 2 * par_d_z_near / _loc2_;
      this._mp.n22 = 2 * par_d_z_near / _loc6_;
      this._mp.n31 = (par_d_right + par_d_left) / _loc2_;
      this._mp.n32 = (par_d_top + par_d_bottom) / _loc2_;
      this._mp.n33 = (par_d_z_far + par_d_z_near) / _loc4_;
      this._mp.n43 = par_d_z_far * par_d_z_near * 2 / _loc4_;
      this._mp.n34 = -1;
      this._mp.n44 = 0;
   }
   function math_matrix4d_perspective(par_d_field_of_view, par_d_aspect_ratio, par_d_z_near, par_d_z_far)
   {
      var _loc4_ = undefined;
      var _loc3_ = undefined;
      par_d_field_of_view = sandy.util.NumberUtil.toRadian(par_d_field_of_view);
      par_d_field_of_view *= 0.5;
      _loc3_ = par_d_z_near * Math.sin(par_d_field_of_view) / Math.cos(par_d_field_of_view);
      _loc4_ = par_d_aspect_ratio * _loc3_;
      this.math_matrix4d_frustum(- _loc4_,_loc4_,- _loc3_,_loc3_,par_d_z_near,par_d_z_far);
   }
   function __loadSimpleProjection(Void)
   {
      this._mp.n12 = this._mp.n13 = this._mp.n14 = this._mp.n21 = this._mp.n23 = this._mp.n24 = this._mp.n31 = this._mp.n32 = this._mp.n34 = this._mp.n41 = this._mp.n42 = this._mp.n44 = 0;
      this._mp.n11 = this._mp.n22 = this._mp.n33 = this._nFocal;
      this._mp.n43 = 1;
   }
   function __updateRotationMatrix(Void)
   {
      return new sandy.core.data.Matrix4(this._vSide.x,this._vSide.y,this._vSide.z,0,this._vUp.x,this._vUp.y,this._vUp.z,0,this._vOut.x,this._vOut.y,this._vOut.z,0,0,0,0,1);
   }
   function __onInterpolation(e)
   {
      var _loc2_ = sandy.core.transform.Interpolator3D(e.getTarget()).getMatrix();
      this._p.x = _loc2_.n14;
      this._p.y = _loc2_.n24;
      this._p.z = _loc2_.n34;
      this._compiled = false;
   }
}
